<?php
/**********************************************************************
***********************************************************************/

$page_security = 'SA_PERSONAL_MATERIAL_TRANSFER';
if (!@$_GET['popup'])
    $path_to_root = "..";
else	
    $path_to_root = "../..";

include_once($path_to_root . "/includes/session.inc");
include_once($path_to_root . "/includes/ui.inc");
include_once($path_to_root . "/inventory/includes/ui/personal_material_transfers_ui.inc");
include_once($path_to_root . "/inventory/includes/db/job_material_issues_db.inc");
include_once($path_to_root . "/inventory/includes/db/job_material_requisitions_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/personal_material_requisitions_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/personal_material_transfers_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/personal_material_issues_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/items_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/items_units_db.inc"); 
include_once($path_to_root . "/admin/db/transactions_db.inc"); 
include_once($path_to_root . "/projects/includes/db/projects_db.inc"); 
include_once($path_to_root . "/includes/project_cost_functions.inc"); 
include_once($path_to_root . "/includes/db/inventory_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/lot_allocations_db.inc");  
include_once($path_to_root . "/inventory/includes/ui/lot_ui.inc");  
include_once($path_to_root . "/inventory/includes/db/lots_db.inc");   
include_once($path_to_root . "/includes/approval_functions.inc");   
include_once($path_to_root . "/payroll/includes/db/employees_db.inc");   

$js = '';
$js .= get_js_open_window(900, 500);
$js .= get_js_date_picker();

global $systypes_array;

if (isset($_GET['ProcessedID'])) {
    page(_($help_context = $systypes_array[ST_PERSONAL_MATERIAL_TRANSFER]), false, false, "", $js);
    
    global $systypes_array;
    
    $trans_no = $_GET['ProcessedID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('pmtr_messages');
    clear_session_variable('pmtr_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if (isset($_GET['BackedOrgID'])) {
    page(_($help_context = $systypes_array[ST_PERSONAL_MATERIAL_TRANSFER]), false, false, "", $js);
    
    global $systypes_array;
    
    $trans_no = $_GET['BackedOrgID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('pmtr_bo_messages');
    clear_session_variable('pmtr_bo_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if (isset($_GET['RejectedID'])) {
    page(_($help_context = $systypes_array[ST_PERSONAL_MATERIAL_TRANSFER]), false, false, "", $js);
    
    global $systypes_array;
    
    $trans_no = $_GET['RejectedID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('pmtr_rj_messages');
    clear_session_variable('pmtr_rj_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if ((isset($_GET['pmr_no']) && is_numeric($_GET['pmr_no'])) || (isset($_POST['pmr_no']) && is_numeric($_POST['pmr_no']))) {
    $_POST['pmr_no'] = isset($_GET['pmr_no']) ? $_GET['pmr_no'] : $_POST['pmr_no'];
    
    $header = get_job_material_requisition_header_record($_POST['pmr_no']);
        if (is_array($header)) {
            if ($header['type'] != ST_PERSONAL_MATERIAL_REQ) {
                page(_($help_context = ''), false, false, "", $js);
                display_error(("Invalid transaction type."));
                display_footer_exit();
            } 
        } else {
            page(_($help_context = ''), false, false, "", $js);
            display_error(("Could not find ".$systypes_array[ST_PERSONAL_MATERIAL_REQ]." record #".$_POST['pmr_no']));
            display_footer_exit();
        }
    
    $page_title = _('New '.$systypes_array[ST_PERSONAL_MATERIAL_TRANSFER]);
    
} elseif ((isset($_GET['pmtr_no']) && is_numeric($_GET['pmtr_no'])) || (isset($_POST['pmtr_no']) && is_numeric($_POST['pmtr_no']))) {
    $_POST['pmtr_no'] = isset($_GET['pmtr_no']) ? $_GET['pmtr_no'] : $_POST['pmtr_no'];
    
    $header = get_job_material_issue_header_record($_POST['pmtr_no']);
        if (is_array($header)) {
            if ($header['type'] != ST_PERSONAL_MATERIAL_TRANSFER) {
                page(_($help_context = ''), false, false, "", $js);
                display_error(("Invalid transaction type."));
                display_footer_exit();
            } 
        } else {
            page(_($help_context = ''), false, false, "", $js);
            display_error(("Could not find ".$systypes_array[ST_PERSONAL_MATERIAL_TRANSFER]." record #".$_POST['pmtr_no']));
            display_footer_exit();
        }
        
    $_POST['pmr_no'] = $header['jmr_no'];
    $page_title = _('Modify '.$systypes_array[ST_PERSONAL_MATERIAL_TRANSFER]." #".$header['trans_no'] );
    
} else {
    page(_($help_context = ''), false, false, "", $js);
    display_error(("Could not find ".$systypes_array[ST_PERSONAL_MATERIAL_TRANSFER]));
    display_footer_exit();
}

page(_($help_context = $page_title), false, false, "", $js);

simple_page_mode(true);

if (isset($_POST['Process_PMTR'])) {
    $msg = save_personal_material_transfers($_POST['pmr_no'], $_POST['pmtr_no'], true);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['BACK_TO_ORIGINATOR_PMTR'])) {
    $msg = back_to_originator_personal_material_transfer($_POST['pmr_no'], $_POST['pmtr_no']);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['REJECT_PMTR'])) {
    $msg = reject_personal_material_transfer($_POST['pmr_no'], $_POST['pmtr_no']);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['Create_PMTR'])) {        
    $msg = save_personal_material_transfers($_POST['pmr_no'], $_POST['pmtr_no']);
        if ($msg['success'] !== true) {
            if (isset($msg["focus_to"])) {
                set_focus($msg["focus_to"]);            
            }
            $transfer_hd_row = get_job_material_issue_header_record($_POST['pmtr_no']);
                if (! is_array($transfer_hd_row)) {
                    $pmtr_no = $_POST['pmtr_no'] = 0; 
                }
            display_error($msg['message']);
        } else {
            display_notification($msg['message']);
            clear_personal_material_transfer_details();
            $Mode = 'RESET';
        }
}

if (isset($_POST['Add_PMTR_LN']) || isset($_POST['Update_PMTR_LN'])) {        
    $msg = handle_save_personal_material_transfer_line($_POST['pmr_no'], $_POST['pmtr_no'], $selected_id);
        if ($msg['success'] !== true) {
            if (isset($msg["focus_to"])) {
                set_focus($msg["focus_to"]);            
            }
            
            if ($_POST['pmtr_no'] > 0) {
                $header = get_job_material_issue_header_record($_POST['pmtr_no']);
                if (! is_array($header)) {
                    $_POST['pmtr_no'] = 0;
                }
            }
            display_error($msg['message']);
        } else {
            display_notification($msg['message']);
            clear_personal_material_transfer_details();
            $Mode = 'RESET';
        }
}

if ($Mode == 'Delete') {
    $msg = handle_delete_personal_material_transfer_line($_POST['pmtr_no'], $selected_id);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } else {
            display_notification($msg['message']);
            clear_personal_material_transfer_details();
            $Mode = 'RESET';
        }
}

if (isset($_POST['cancel']) || isset($_POST['Refresh']) || $Mode == 'RESET') {
    clear_personal_material_transfer_details();
    
    $Mode = 'RESET';
    $selected_id = -1;
}

global $Ajax;

start_form();

    if (isset($_POST['pmr_no']) && $_POST['pmr_no'] > 0) {
        hidden('pmr_no', $_POST['pmr_no']);
    } else {
        $_POST['pmr_no'] = 0;
    }   
        
    if (isset($_POST['pmtr_no']) && $_POST['pmtr_no'] > 0) {
        hidden('pmtr_no', $_POST['pmtr_no']);
        $button_name = 'Save';
    } else {
        $_POST['pmtr_no'] = 0;
        $button_name = 'Create';
    }

    $Ajax->activate('_page_body');
    $Ajax->activate('All_details');
    div_start('All_details');
    
        $req_hd_row = display_personal_material_requisition_header_details($_POST['pmr_no'], $_POST['pmtr_no']);
        
        display_personal_material_transfer_header($_POST['pmtr_no'], $req_hd_row);

        display_personal_material_transfer_details($_POST['pmr_no'], $_POST['pmtr_no'], $selected_id, $Mode);

            submit_center_first('Create_PMTR', _("$button_name ".$systypes_array[ST_PERSONAL_MATERIAL_TRANSFER]), '', 'default');    
            
            $header = get_job_material_issue_header($_POST['pmtr_no']);
            if (is_array($header)) {
                submit('Process_PMTR', _("Process ".$systypes_array[ST_PERSONAL_MATERIAL_TRANSFER]), true,  _("Process"), false, ICON_SUBMIT);
            } 
            
            submit_center_last('Refresh', 'Refresh', 'Refresh', false, ICON_SUBMIT);
            
            start_table();
                if (is_array($header)) {
                    br(2);
                    submit_center_first('REJECT_PMTR', _("Reject ".$systypes_array[ST_PERSONAL_MATERIAL_TRANSFER]), '', true, ICON_DELETE);  
                    
                    submit('BACK_TO_ORIGINATOR_PMTR', 'Back To Originator', true, 'Back To Originator', false, ICON_SUBMIT);
                }
            end_table();

    div_end();
    
end_form(2);
end_page(@$_GET['popup'], false, false);        

?>